---
title: XMLHttpRequest.open()
slug: Web/API/XMLHttpRequest/open
tags:
  - API
  - HTTP
  - Method
  - NeedsExample
  - Reference
  - XHR
  - XMLHttpRequest
  - open
---
<div>{{APIRef('XMLHttpRequest')}}</div>

<p>The {{domxref("XMLHttpRequest")}} method <code><strong>open()</strong></code> initializes a newly-created request, or re-initializes an existing one.</p>

<div class="note"><strong>Note:</strong> Calling this method for an already active request (one for which <code>open()</code> has already been called) is the equivalent of calling {{domxref("XMLHttpRequest.abort", "abort()")}}.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>XMLHttpRequest</var>.open(<var>method</var>, <var>url</var>[, <var>async</var>[, <var>user</var>[, <var>password</var>]]])
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>method</code></dt>
 <dd>The <a href="/en-US/docs/Web/HTTP/Methods">HTTP request method</a> to use, such as <code>"GET"</code>, <code>"POST"</code>, <code>"PUT"</code>, <code>"DELETE"</code>, etc. Ignored for non-HTTP(S) URLs.</dd>
 <dt><code>url</code></dt>
 <dd>A {{domxref("DOMString")}} representing the URL to send the request to.</dd>
 <dt><code>async</code> {{optional_inline}}</dt>
 <dd>An optional Boolean parameter, defaulting to <code>true</code>, indicating whether or not to perform the operation asynchronously. If this value is <code>false</code>, the <code>send()</code> method does not return until the response is received. If <code>true</code>, notification of a completed transaction is provided using event listeners. This <em>must</em> be true if the <code>multipart</code> attribute is <code>true</code>, or an exception will be thrown.
 <div class="note"><strong>Note:</strong> Synchronous requests on the main thread can be easily disruptive to the user experience and should be avoided; in fact, many browsers have deprecated synchronous XHR support on the main thread entirely. Synchronous requests are permitted in {{domxref("Worker")}}s.</div>
 </dd>
 <dt><code>user</code> {{optional_inline}}</dt>
 <dd>The optional user name to use for authentication purposes; by default, this is the <code>null</code> value.</dd>
 <dt><code>password</code> {{optional_inline}}</dt>
 <dd>The optional password to use for authentication purposes; by default, this is the <code>null</code> value.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('XMLHttpRequest', '#the-open()-method', 'open()')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>WHATWG living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.XMLHttpRequest.open")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a></li>
 <li>Related {{domxref("XMLHttpRequest")}} methods: {{domxref("XMLHttpRequest.setRequestHeader", "setRequestHeader()")}},{{domxref("XMLHttpRequest.send", "send()")}}, and {{domxref("XMLHttpRequest.abort", "abort()")}}</li>
</ul>
